=== debian/changelog ===
qemu (1:2.3+dfsg-5ubuntu9.4~cloud4) trusty-liberty; urgency=medium

  * Fix ambiguous machine types (LP: #1641532)
    - make utopic a true 2.1 type (was floating with qemu version)
    - drop duplicate ubuntu alias from utopic (should only point to vivid)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 19 Jan 2017 14:32:49 +0100

qemu (1:2.3+dfsg-5ubuntu9.4~cloud3) trusty-liberty; urgency=medium

  * Fix core dump when unable to allocate ram for new virtual 
    machine.  Exits with error and log message instead. (LP: #1650067)

 -- Dave Chiluk <chiluk@ubuntu.com>  Thu, 02 Feb 2017 14:30:44 -0600

qemu (1:2.3+dfsg-5ubuntu9.4~cloud2) trusty-liberty; urgency=medium

  * SECURITY REGRESSION: crash on migration with memory stats enabled
    (LP: #1612089)
    - debian/patches/CVE-2016-5403.patch: disable for now pending
      investigation.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 25 Aug 2016 16:00:36 -0400

qemu (1:2.3+dfsg-5ubuntu9.4~cloud1) trusty-liberty; urgency=medium

  * USN-3047-1: Security updates for QEMU vulnerabilities (LP: #1611123).
  * SECURITY UPDATE: DoS and possible host code execution in 53C9X Fast
    SCSI Controller
    - debian/patches/CVE-2016-4439.patch: check length in hw/scsi/esp.c.
    - CVE-2016-4439
  * SECURITY UPDATE: DoS in 53C9X Fast SCSI Controller
    - debian/patches/CVE-2016-4441.patch: check DMA length in
      hw/scsi/esp.c.
    - CVE-2016-4441
  * SECURITY UPDATE: infinite loop in vmware_vga
    - debian/patches/CVE-2016-4453.patch: limit fifo commands in
      hw/display/vmware_vga.c.
    - CVE-2016-4453
  * SECURITY UPDATE: DoS or host memory leakage in vmware_vga
    - debian/patches/CVE-2016-4454.patch: fix sanity checks in
      hw/display/vmware_vga.c.
    - CVE-2016-4454
  * SECURITY UPDATE: DoS in VMWARE PVSCSI paravirtual SCSI bus
    - debian/patches/CVE-2016-4952.patch: check command descriptor ring
      buffer size in hw/scsi/vmw_pvscsi.c.
    - CVE-2016-4952
  * SECURITY UPDATE: MegaRAID SAS 8708EM2 host memory leakage
    - debian/patches/CVE-2016-5105.patch: initialise local configuration
      data buffer in hw/scsi/megasas.c.
    - CVE-2016-5105
  * SECURITY UPDATE: DoS in MegaRAID SAS 8708EM2
    - debian/patches/CVE-2016-5106.patch: use appropriate property buffer
      size in hw/scsi/megasas.c.
    - CVE-2016-5106
  * SECURITY UPDATE: DoS in MegaRAID SAS 8708EM2
    - debian/patches/CVE-2016-5107.patch: check read_queue_head index
      value in hw/scsi/megasas.c.
    - CVE-2016-5107
  * SECURITY UPDATE: DoS or code execution via crafted iSCSI asynchronous
    I/O ioctl call
    - debian/patches/CVE-2016-5126.patch: avoid potential overflow in
      block/iscsi.c.
    - CVE-2016-5126
  * SECURITY UPDATE: DoS in 53C9X Fast SCSI Controller
    - debian/patches/CVE-2016-5238.patch: check buffer length before
      reading scsi command in hw/scsi/esp.c.
    - CVE-2016-5238
  * SECURITY UPDATE: MegaRAID SAS 8708EM2 host memory leakage
    - debian/patches/CVE-2016-5337.patch: null terminate bios version
      buffer in hw/scsi/megasas.c.
    - CVE-2016-5337
  * SECURITY UPDATE: DoS or code execution in 53C9X Fast SCSI Controller
    - debian/patches/CVE-2016-5338.patch: check TI buffer index in
      hw/scsi/esp.c.
    - CVE-2016-5338
  * SECURITY UPDATE: DoS via unbounded memory allocation
    - debian/patches/CVE-2016-5403.patch: check size in hw/virtio/virtio.c.
    - CVE-2016-5403
  * SECURITY UPDATE: oob write access while reading ESP command
    - debian/patches/CVE-2016-6351.patch: make cmdbuf big enough for
      maximum CDB size and handle migration in hw/scsi/esp.c,
      include/hw/scsi/esp.h, include/migration/vmstate.h.
    - CVE-2016-6351

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 09 Aug 2016 09:52:03 -0400

qemu (1:2.3+dfsg-5ubuntu9.4~cloud0) trusty-liberty; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Fri, 13 May 2016 10:58:24 +0000

qemu (1:2.3+dfsg-5ubuntu9.4) wily-security; urgency=medium

  * SECURITY UPDATE: denial of service via multiple eof_timers in ohci
    - debian/patches/CVE-2016-2391.patch: allocate timer only once in
      hw/usb/hcd-ohci.c.
    - CVE-2016-2391
  * SECURITY UPDATE: denial of service in in remote NDIS control message
    handling
    - debian/patches/CVE-2016-2392.patch: check USB configuration
      descriptor object in hw/usb/dev-network.c.
    - CVE-2016-2392
  * SECURITY UPDATE: denial of service or host information leak in USB Net
    device emulation support
    - debian/patches/CVE-2016-2538.patch: check RNDIS buffer offsets and
      length in hw/usb/dev-network.c.
    - CVE-2016-2538
  * SECURITY UPDATE: denial of service via infinite loop in ne2000
    - debian/patches/CVE-2016-2841.patch: heck ring buffer control
      registers in hw/net/ne2000.c.
    - CVE-2016-2841
  * SECURITY UPDATE: denial of service via payload length in crafted packet
    - debian/patches/CVE-2016-2857.patch: check packet payload length in
      net/checksum.c.
    - CVE-2016-2857
  * SECURITY UPDATE: denial of service in PRNG support
    - debian/patches/CVE-2016-2858.patch: add request queue support to
      rng-random in backends/rng-egd.c, backends/rng-random.c,
      backends/rng.c, include/sysemu/rng.h.
    - CVE-2016-2858
  * SECURITY UPDATE: arbitrary host code execution via VGA module
    - debian/patches/CVE-2016-3710.patch: fix banked access bounds checking
      in hw/display/vga.c.
    - CVE-2016-3710
  * SECURITY UPDATE: denial of service via VGA module
    - debian/patches/CVE-2016-3712.patch: make sure vga register setup for
      vbe stays intact in hw/display/vga.c.
    - CVE-2016-3712
  * SECURITY UPDATE: denial of service in Luminary Micro Stellaris Ethernet
    - debian/patches/CVE-2016-4001.patch: check packet length against
      receive buffer in hw/net/stellaris_enet.c.
    - CVE-2016-4001

